This section describes how to style the text used throughout a chart, including titles, labels and other elements. It covers font options, applying multiple font styles and inline images within a single text element.
Fonts Copy Link
Each chart element has font options, including fontFamily, fontSize and fontWeight. The font options for the whole chart can be set once using theme parameters.
Font Families Copy Link
Font families can accept the following value types:
| Syntax | Description |
|---|---|
string | A CSS font-family value, such as 'Arial, sans-serif'. |
{ googleFont: 'IBM Plex Sans' } | A Google font. You must load the font or ask the chart to load it for you, see Google Fonts below. |
['Arial', 'sans-serif'] | An array of fonts. Each item can be a string font name or a { googleFont: "..." } object. The browser will attempt to use the first font and fall back to later fonts if the first one fails to load or is not available on the host system. |
Google Fonts Copy Link
import {
AgChartOptions,
AgCharts,
AnimationModule,
CategoryAxisModule,
ContextMenuModule,
CrosshairModule,
LegendModule,
LineSeriesModule,
ModuleRegistry,
NumberAxisModule,
} from "ag-charts-enterprise";
ModuleRegistry.registerModules([
AnimationModule,
CategoryAxisModule,
CrosshairModule,
LegendModule,
LineSeriesModule,
NumberAxisModule,
ContextMenuModule,
]);
const options: AgChartOptions = {
title: {
text: "Title in Pacifico",
fontFamily: { googleFont: "Pacifico" },
fontSize: 25,
maxHeight: 50,
},
subtitle: {
text: "Subtitle in DM Serif Text",
fontFamily: [{ googleFont: "DM Serif Text" }, "monospace"],
fontSize: 18,
},
data: [
{ month: "Jan", avgTemp: 2.3, iceCreamSales: 162000 },
{ month: "Mar", avgTemp: 6.3, iceCreamSales: 302000 },
{ month: "May", avgTemp: 16.2, iceCreamSales: 800000 },
{ month: "Jul", avgTemp: 22.8, iceCreamSales: 1254000 },
{ month: "Sep", avgTemp: 14.5, iceCreamSales: 950000 },
{ month: "Nov", avgTemp: 8.9, iceCreamSales: 200000 },
],
series: [
{
type: "line",
xKey: "month",
yKey: "iceCreamSales",
yName: "Ice Cream Sales",
},
],
axes: {
y: {
type: "number",
label: { fontFamily: ["Helvetica", "Arial", "sans-serif"] },
},
x: {
type: "category",
label: {
fontFamily: { googleFont: "Orbitron" },
fontSize: 12,
},
},
},
loadGoogleFonts: true,
};
options.container = document.getElementById("myChart");
const chart = AgCharts.create(options);
To prevent potential licensing and privacy implications, the chart will not load Google fonts unless requested to.
If you want to use Google fonts, you should either:
- Set the chart's
loadGoogleFontsoption totrueand use the{ googleFont: "..." }object for the chart to load the font from Google's CDN. - Load the font yourself using a
@font-facerule in your application's CSS.
If the font has not been loaded through either of the above methods, the theme will fall back to the most appropriate font available on the system.
In the above example:
- The
loadGoogleFontsoption is set totrueto automatically load Google fonts. - The title uses the Google font
Pacifico. - The subtitle uses the Google font
DM Serif Textwith a fallback tomonospace. - The left axis uses the local system font
Helveticawith a fallback toArialthensans-serif. - The bottom axis uses the Google font
Orbitron.
Multi-Style Text Elements Copy Link
The chart title, subtitle and footnote support multiple font styles within one element.
import {
AgChartOptions,
AgCharts,
AnimationModule,
CategoryAxisModule,
ContextMenuModule,
CrosshairModule,
LegendModule,
LineSeriesModule,
ModuleRegistry,
NumberAxisModule,
} from "ag-charts-enterprise";
ModuleRegistry.registerModules([
AnimationModule,
CategoryAxisModule,
CrosshairModule,
LegendModule,
LineSeriesModule,
NumberAxisModule,
ContextMenuModule,
]);
const options: AgChartOptions = {
title: {
text: [
{
text: "2025",
fontStyle: "italic",
},
{
text: " Financial Growth ",
fontSize: 26,
},
{
text: "Overview",
color: "#ff7f0e",
fontFamily: "monospace",
},
],
color: "#1f77b4",
fontSize: 34,
fontWeight: "bold",
},
subtitle: {
text: [
{ text: "Quarterly Revenue vs Expenses Analysis", color: "#2ca02c" },
{ text: " for Q1 & Q2 2025", color: "#d62728" },
],
fontSize: 18,
fontWeight: "bold",
},
footnote: {
text: [
{ text: "All of this " },
{ text: "data is fictitious", fontWeight: "bold", fontSize: 15 },
{ text: " and for example purposes only." },
],
},
data: [
{ quarter: "Q1", revenue: 500000, expenses: 450000 },
{ quarter: "Q2", revenue: 750000, expenses: 600000 },
{ quarter: "Q3", revenue: 1000000, expenses: 800000 },
{ quarter: "Q4", revenue: 1200000, expenses: 950000 },
],
series: [
{
type: "line",
xKey: "quarter",
yKey: "revenue",
yName: "Revenue",
},
{
type: "line",
xKey: "quarter",
yKey: "expenses",
yName: "Expenses",
},
],
};
options.container = document.getElementById("myChart");
const chart = AgCharts.create(options);
{
title: {
text: [
{
text: '2025',
fontStyle: 'italic',
},
{
text: ' Financial Growth ',
fontSize: 26,
},
{
text: 'Overview',
color: '#ff7f0e',
fontFamily: 'monospace',
},
],
},
}In the above example:
- Pass an array of
TextSegmentobjects, each with atextproperty and font style overrides. - The top-level font options on each element apply to all segments, unless a segment overrides them.
Label Formatters with Multi-Style Text Copy Link
Series and axis label formatters also support multiple font styles.
import {
AgChartOptions,
AgCharts,
AnimationModule,
BarSeriesModule,
CategoryAxisModule,
ContextMenuModule,
CrosshairModule,
LegendModule,
ModuleRegistry,
NumberAxisModule,
} from "ag-charts-enterprise";
import { getData } from "./data";
ModuleRegistry.registerModules([
AnimationModule,
BarSeriesModule,
CategoryAxisModule,
CrosshairModule,
LegendModule,
NumberAxisModule,
ContextMenuModule,
]);
const options: AgChartOptions = {
title: {
text: "Product Sales Performance",
},
subtitle: {
text: "Q4 2025 Sales vs Target",
},
data: getData(),
series: [
{
type: "bar",
xKey: "product",
yKey: "sales",
yName: "Sales",
label: {
enabled: true,
formatter: ({ value }) => {
return [
{
text: value.toString(),
fontSize: 18,
fontWeight: "bold",
color: "white",
},
{
text: "\nunits",
fontSize: 11,
color: "rgba(255, 255, 255, 0.8)",
},
];
},
},
},
],
axes: {
y: {
type: "number",
label: {
formatter: ({ value }) => {
if (value === 0) return "0";
return [
{
text: value.toString(),
fontSize: 13,
fontWeight: "bold",
},
{
text: " units",
fontSize: 10,
},
];
},
},
},
},
};
options.container = document.getElementById("myChart");
const chart = AgCharts.create(options);
export interface TData {
product: string;
sales: number;
target: number;
}
export function getData(): TData[] {
return [
{ product: "Laptops", sales: 145, target: 120 },
{ product: "Tablets", sales: 98, target: 100 },
{ product: "Smartphones", sales: 203, target: 180 },
{ product: "Monitors", sales: 87, target: 90 },
{ product: "Keyboards", sales: 62, target: 55 },
];
}
{
series: [
{
type: 'bar',
label: {
formatter: ({ value }) => [
{ text: value.toString(), fontSize: 18, fontWeight: 'bold', color: 'white' },
{ text: '\nunits', fontSize: 11, color: 'rgba(255, 255, 255, 0.8)' },
],
},
},
],
}In the above example:
- The formatter returns an array of
TextSegmentobjects instead of a string. - The first segment shows the value in large, bold, white text.
- The second segment displays "units" in smaller, semi-transparent text.
- Each text segment can have independent font styling (size, weight, color, style, family).
- Newline characters (
\n) separate segments across multiple lines.
Aligning Segments Vertically Copy Link
Segments share a baseline by default. Set verticalAlign: 'middle' to centre it instead.
import {
AgChartOptions,
AgCharts,
BarSeriesModule,
CategoryAxisModule,
ModuleRegistry,
NumberAxisModule,
} from "ag-charts-community";
function buildTitle(verticalAlign: "baseline" | "top" | "middle" | "bottom") {
return [
{ text: "🚀 ", fontSize: 36, verticalAlign },
{ text: "Quarterly ", fontSize: 16, verticalAlign },
{ text: "Spending ", fontSize: 28, verticalAlign },
{ text: "Growth", fontSize: 20, verticalAlign },
];
}
ModuleRegistry.registerModules([
BarSeriesModule,
CategoryAxisModule,
NumberAxisModule,
]);
const options: AgChartOptions = {
title: {
text: buildTitle("baseline"),
fontWeight: "bold",
},
data: [
{ quarter: "Q1", sales: 120 },
{ quarter: "Q2", sales: 180 },
{ quarter: "Q3", sales: 240 },
{ quarter: "Q4", sales: 310 },
],
series: [
{
type: "bar",
xKey: "quarter",
yKey: "sales",
yName: "Sales",
},
],
};
options.container = document.getElementById("myChart");
const chart = AgCharts.create(options);
function setVerticalAlign(event: Event) {
const verticalAlign = (event.target as HTMLInputElement).value as
| "baseline"
| "top"
| "middle"
| "bottom";
chart.updateDelta({ title: { text: buildTitle(verticalAlign) } });
}
if (typeof window !== "undefined") {
// Attach external event handlers to window so they can be called from index.html
(<any>window).setVerticalAlign = setVerticalAlign;
}
{
title: {
text: [
{ text: '🚀 ', fontSize: 36, verticalAlign: 'baseline' },
{ text: 'Quarterly ', fontSize: 16, verticalAlign: 'baseline' },
{ text: 'Spending ', fontSize: 28, verticalAlign: 'baseline' },
{ text: 'Growth', fontSize: 20, verticalAlign: 'baseline' },
],
},
}In this example:
- Use the buttons to align every segment in the title, moving the large and small text together.
'baseline'and'bottom'differ where text has descenders (such as thep,y, andgin the title): baseline aligns the text baselines, while bottom aligns the lowest pixel of each segment.verticalAlignapplies per segment, so a single line can also mix baseline-aligned text with centred emoji or icon glyphs.
Displaying Images and Text Copy Link
Text Segments support adding inline images using multiple approaches.
Inline Image Segments Copy Link
import {
AgChartOptions,
AgCharts,
AnimationModule,
BarSeriesModule,
CategoryAxisModule,
LegendModule,
ModuleRegistry,
NumberAxisModule,
} from "ag-charts-enterprise";
import { TData, getData } from "./data";
const flagsUrl = "https://www.ag-grid.com/charts/example-assets/flags/";
const arrowUp =
"data:image/svg+xml;utf8," +
encodeURIComponent(
'<svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 16 16"><path fill="#22c55e" d="M8 2 14 12H2z"/></svg>',
);
const arrowDown =
"data:image/svg+xml;utf8," +
encodeURIComponent(
'<svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 16 16"><path fill="#d62728" d="M8 14 2 4h12z"/></svg>',
);
ModuleRegistry.registerModules([
AnimationModule,
BarSeriesModule,
CategoryAxisModule,
LegendModule,
NumberAxisModule,
]);
const options: AgChartOptions = {
title: {
text: [
{ text: "Top Markets " },
{
type: "image",
url: flagsUrl + "us.png",
width: 24,
height: 18,
verticalAlign: "middle",
},
{ text: " 2025", fontWeight: "bold" },
],
fontSize: 22,
},
subtitle: {
text: "Quarterly revenue by country",
},
data: getData(),
series: [
{
type: "bar",
xKey: "code",
yKey: "revenue",
yName: "Revenue",
label: {
enabled: true,
fill: { ref: "backgroundColor" } as any,
color: { ref: "foregroundColor" },
formatter: ({ datum }) => {
const d = datum as TData;
return [
{ text: `${d.revenue}M `, fontWeight: "bold" },
{
type: "image",
url: d.delta >= 0 ? arrowUp : arrowDown,
width: 12,
height: 12,
verticalAlign: "middle",
},
];
},
},
},
],
axes: {
x: {
type: "category",
label: {
formatter: ({ value }) => [
{
type: "image",
url: flagsUrl + `${value}.png`,
width: 20,
height: 15,
verticalAlign: "middle",
},
{ text: ` ${String(value).toUpperCase()}`, fontWeight: "bold" },
],
},
},
y: {
type: "number",
label: { formatter: ({ value }) => `$${value}M` },
},
},
};
options.container = document.getElementById("myChart");
const chart = AgCharts.create(options);
export interface TData {
code: string;
name: string;
revenue: number;
delta: number;
}
export function getData(): TData[] {
return [
{ code: "us", name: "United States", revenue: 482, delta: 18 },
{ code: "gb", name: "United Kingdom", revenue: 264, delta: -7 },
{ code: "de", name: "Germany", revenue: 318, delta: 12 },
{ code: "fr", name: "France", revenue: 197, delta: 4 },
{ code: "br", name: "Brazil", revenue: 132, delta: -3 },
];
}
Provide any image URL through the url property:
{
axes: {
x: {
type: 'category',
label: {
formatter: ({ value }) => [
{
type: 'image',
url: flagsUrl + `${value}.png`,
width: 20,
height: 15,
verticalAlign: 'middle',
},
{ text: ` ${String(value).toUpperCase()}`, fontWeight: 'bold' },
],
},
},
},
}An image segment uses type: 'image' and supports:
widthandheight- these are required.verticalAlign- vertical alignment against the text.cornerRadius,padding- for styling the image box.backgroundFill- also shows as a placeholder while the image loads or if it fails.overflowStrategy- drop priority for label collision avoidance.'hide'- images are dropped before text is truncated.'keep'images take priority, dropping trailing text first and only dropping the image if it cannot fit on its own.
Block Image Segments Copy Link
Set block: true on an image that begins a row, and the text segments that follow wrap into a column to its right instead of continuing on the same line.
import {
AgChartOptions,
AgCharts,
AnimationModule,
LegendModule,
ModuleRegistry,
TreemapSeriesModule,
} from "ag-charts-enterprise";
import { TData, getData } from "./data";
const brandIconsUrl = "https://www.ag-grid.com/charts/example-assets/brand-icons/";
ModuleRegistry.registerModules([
AnimationModule,
LegendModule,
TreemapSeriesModule,
]);
const options: AgChartOptions = {
data: getData(),
series: [
{
type: "treemap",
labelKey: "name",
sizeKey: "value",
group: {
label: {
fontSize: 14,
color: "#fff",
},
},
tile: {
label: {
formatter: ({ datum }) => {
const d = datum as TData;
return [
{
type: "image",
url: brandIconsUrl + `${d.slug}.svg`,
width: 36,
height: 36,
block: true,
padding: 6,
backgroundFill: "rgba(0, 0, 0, 0.35)",
cornerRadius: 8,
},
{ text: d.name, fontWeight: "bold", verticalAlign: "middle" },
{ text: `\n$${d.value}B`, color: "rgba(0, 0, 0, 0.6)" },
];
},
fontSize: 16,
minimumFontSize: 10,
spacing: 2,
},
secondaryLabel: { enabled: false },
},
},
],
title: { text: "Top Tech Brand Values, 2024" },
subtitle: { text: "Brand value in USD billions" },
};
options.container = document.getElementById("myChart");
const chart = AgCharts.create(options);
export interface TData {
name: string;
slug: string;
value: number;
}
export interface TGroup {
name: string;
children: TData[];
}
export function getData(): TGroup[] {
return [
{
name: "Hardware",
children: [
{ name: "Apple", slug: "apple", value: 383 },
{ name: "NVIDIA", slug: "nvidia", value: 244 },
{ name: "Intel", slug: "intel", value: 87 },
{ name: "Tesla", slug: "tesla", value: 67 },
],
},
{
name: "Software",
children: [
{ name: "Google", slug: "google", value: 333 },
{ name: "Meta", slug: "meta", value: 196 },
{ name: "SAP", slug: "sap", value: 58 },
{ name: "Shopify", slug: "shopify", value: 36 },
],
},
{
name: "Services",
children: [
{ name: "Netflix", slug: "netflix", value: 38 },
{ name: "Spotify", slug: "spotify", value: 21 },
{ name: "Airbnb", slug: "airbnb", value: 24 },
{ name: "Uber", slug: "uber", value: 32 },
{ name: "PayPal", slug: "paypal", value: 27 },
{ name: "Stripe", slug: "stripe", value: 14 },
],
},
];
}
{
type: 'image',
url: brandIconsUrl + `${datum.slug}.svg`,
width: 36,
height: 36,
block: true,
padding: 6,
backgroundFill: 'rgba(0, 0, 0, 0.35)',
cornerRadius: 8,
}In this example:
- The block image segment anchors to the left of its row, with the following text wrapping into a column to its right. The column can span multiple lines.
- Defaults
verticalAlignto'middle', centring the image against the text column beside it. - Is dropped when its row has no space for it, leaving the text to use the full width. This is controlled by the
overflowStrategyoption.
Emojis and Font Icons Copy Link
Emojis and font icons render through native canvas, with no API changes required. Both can be mixed freely with text within a single element.
import {
AgChartOptions,
AgCharts,
AnimationModule,
BarSeriesModule,
CategoryAxisModule,
LegendModule,
ModuleRegistry,
NumberAxisModule,
} from "ag-charts-enterprise";
import { TData, getData } from "./data";
const data = getData();
// Keycap number emoji (U+0031..U+0035 + U+FE0F + U+20E3) rank each country by position.
const rankEmoji = ["1️⃣", "2️⃣", "3️⃣", "4️⃣", "5️⃣"];
const rankByCountry = new Map(data.map((d, i) => [d.country, rankEmoji[i]]));
const ICON_FAMILY_SOLID = "Font Awesome 6 Free";
const SOLID_WEIGHT = 900;
const ICON_CHART_LINE = "";
const ICON_STAR = "";
ModuleRegistry.registerModules([
AnimationModule,
BarSeriesModule,
CategoryAxisModule,
LegendModule,
NumberAxisModule,
]);
const options: AgChartOptions = {
title: {
text: [
{
text: `${ICON_CHART_LINE} `,
fontFamily: ICON_FAMILY_SOLID,
fontWeight: SOLID_WEIGHT,
color: "#1f77b4",
verticalAlign: "middle",
},
{ text: "Top Markets 2025", fontWeight: "bold" },
{
text: ` ${ICON_STAR}`,
fontFamily: ICON_FAMILY_SOLID,
fontWeight: SOLID_WEIGHT,
color: "#f1c40f",
verticalAlign: "middle",
},
],
fontSize: 22,
},
subtitle: {
text: [
{
text: `${ICON_CHART_LINE} `,
fontFamily: ICON_FAMILY_SOLID,
fontWeight: SOLID_WEIGHT,
color: "#1f77b4",
verticalAlign: "middle",
},
{ text: "Quarterly revenue by country" },
],
},
data,
series: [
{
type: "bar",
xKey: "country",
yKey: "revenue",
yName: "Revenue",
label: {
enabled: true,
formatter: ({ datum }) => `${(datum as TData).revenue}M`,
},
},
],
axes: {
x: {
type: "category",
label: {
formatter: ({ value }) => [
{
text: `${rankByCountry.get(String(value)) ?? ""} `,
fontSize: 18,
verticalAlign: "middle",
},
{ text: String(value), fontWeight: "bold", verticalAlign: "middle" },
],
},
},
y: {
type: "number",
label: { formatter: ({ value }) => `$${value}M` },
},
},
};
options.container = document.getElementById("myChart");
const chart = AgCharts.create(options);
export interface TData {
country: string;
revenue: number;
delta: number;
}
export function getData(): TData[] {
return [
{ country: "US", revenue: 482, delta: 18 },
{ country: "GB", revenue: 264, delta: -7 },
{ country: "DE", revenue: 318, delta: 12 },
{ country: "JP", revenue: 197, delta: 4 },
{ country: "BR", revenue: 132, delta: -3 },
];
}
In this example:
- The axis labels use number emojis within the
textproperty of aTextSegmentobject. - The title uses a FontAwesome glyph to add a chart icon and a star.
- Font icons set the icon font with
fontFamilyandfontWeighton the segment and use the icon's glyph as thetext. - They are loaded via CSS, with the chart downloading any referenced fonts and re-rendering once they are ready.
- Font icons set the icon font with
{
axes: {
x: {
type: 'category',
label: {
formatter: ({ value }) => [
{ text: '1️⃣ ', fontSize: 18, verticalAlign: 'middle' },
{ text: String(value), fontWeight: 'bold', verticalAlign: 'middle' },
],
},
},
},
}{
title: {
text: [
{
text: `${ICON_CHART_LINE} `,
fontFamily: ICON_FAMILY_SOLID,
fontWeight: SOLID_WEIGHT,
color: '#1f77b4',
verticalAlign: 'middle',
},
{ text: 'Top Markets 2025', fontWeight: 'bold' },
{
text: ` ${ICON_STAR}`,
fontFamily: ICON_FAMILY_SOLID,
fontWeight: SOLID_WEIGHT,
color: '#f1c40f',
verticalAlign: 'middle',
},
],
fontSize: 22,
},
} API Reference Copy Link
See API Options for the full list of font options on each chart element.

This section describes how to style the text used throughout a chart, including titles, labels and other elements. It covers font options, applying multiple font styles and inline images within a single text element.
Fonts Copy Link
Each chart element has font options, including fontFamily, fontSize and fontWeight. The font options for the whole chart can be set once using theme parameters.
Font Families Copy Link
Font families can accept the following value types:
| Syntax | Description |
|---|---|
string | A CSS font-family value, such as 'Arial, sans-serif'. |
{ googleFont: 'IBM Plex Sans' } | A Google font. You must load the font or ask the chart to load it for you, see Google Fonts below. |
['Arial', 'sans-serif'] | An array of fonts. Each item can be a string font name or a { googleFont: "..." } object. The browser will attempt to use the first font and fall back to later fonts if the first one fails to load or is not available on the host system. |
Google Fonts Copy Link
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
AnimationModule,
CategoryAxisModule,
ContextMenuModule,
CrosshairModule,
LegendModule,
LineSeriesModule,
ModuleRegistry,
NumberAxisModule,
} from "ag-charts-enterprise";
ModuleRegistry.registerModules([
AnimationModule,
CategoryAxisModule,
CrosshairModule,
LegendModule,
LineSeriesModule,
NumberAxisModule,
ContextMenuModule,
]);
const ChartExample = defineComponent({
template: `
<ag-charts
:options="options"
/>
`,
components: {
"ag-charts": AgCharts,
},
setup(props) {
const options = ref<AgChartOptions>({
title: {
text: "Title in Pacifico",
fontFamily: { googleFont: "Pacifico" },
fontSize: 25,
maxHeight: 50,
},
subtitle: {
text: "Subtitle in DM Serif Text",
fontFamily: [{ googleFont: "DM Serif Text" }, "monospace"],
fontSize: 18,
},
data: [
{ month: "Jan", avgTemp: 2.3, iceCreamSales: 162000 },
{ month: "Mar", avgTemp: 6.3, iceCreamSales: 302000 },
{ month: "May", avgTemp: 16.2, iceCreamSales: 800000 },
{ month: "Jul", avgTemp: 22.8, iceCreamSales: 1254000 },
{ month: "Sep", avgTemp: 14.5, iceCreamSales: 950000 },
{ month: "Nov", avgTemp: 8.9, iceCreamSales: 200000 },
],
series: [
{
type: "line",
xKey: "month",
yKey: "iceCreamSales",
yName: "Ice Cream Sales",
},
],
axes: {
y: {
type: "number",
label: { fontFamily: ["Helvetica", "Arial", "sans-serif"] },
},
x: {
type: "category",
label: {
fontFamily: { googleFont: "Orbitron" },
fontSize: 12,
},
},
},
loadGoogleFonts: true,
});
return {
options,
};
},
});
createApp(ChartExample).mount("#app");
To prevent potential licensing and privacy implications, the chart will not load Google fonts unless requested to.
If you want to use Google fonts, you should either:
- Set the chart's
loadGoogleFontsoption totrueand use the{ googleFont: "..." }object for the chart to load the font from Google's CDN. - Load the font yourself using a
@font-facerule in your application's CSS.
If the font has not been loaded through either of the above methods, the theme will fall back to the most appropriate font available on the system.
In the above example:
- The
loadGoogleFontsoption is set totrueto automatically load Google fonts. - The title uses the Google font
Pacifico. - The subtitle uses the Google font
DM Serif Textwith a fallback tomonospace. - The left axis uses the local system font
Helveticawith a fallback toArialthensans-serif. - The bottom axis uses the Google font
Orbitron.
Multi-Style Text Elements Copy Link
The chart title, subtitle and footnote support multiple font styles within one element.
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
AnimationModule,
CategoryAxisModule,
ContextMenuModule,
CrosshairModule,
LegendModule,
LineSeriesModule,
ModuleRegistry,
NumberAxisModule,
} from "ag-charts-enterprise";
ModuleRegistry.registerModules([
AnimationModule,
CategoryAxisModule,
CrosshairModule,
LegendModule,
LineSeriesModule,
NumberAxisModule,
ContextMenuModule,
]);
const ChartExample = defineComponent({
template: `
<ag-charts
:options="options"
/>
`,
components: {
"ag-charts": AgCharts,
},
setup(props) {
const options = ref<AgChartOptions>({
title: {
text: [
{
text: "2025",
fontStyle: "italic",
},
{
text: " Financial Growth ",
fontSize: 26,
},
{
text: "Overview",
color: "#ff7f0e",
fontFamily: "monospace",
},
],
color: "#1f77b4",
fontSize: 34,
fontWeight: "bold",
},
subtitle: {
text: [
{ text: "Quarterly Revenue vs Expenses Analysis", color: "#2ca02c" },
{ text: " for Q1 & Q2 2025", color: "#d62728" },
],
fontSize: 18,
fontWeight: "bold",
},
footnote: {
text: [
{ text: "All of this " },
{ text: "data is fictitious", fontWeight: "bold", fontSize: 15 },
{ text: " and for example purposes only." },
],
},
data: [
{ quarter: "Q1", revenue: 500000, expenses: 450000 },
{ quarter: "Q2", revenue: 750000, expenses: 600000 },
{ quarter: "Q3", revenue: 1000000, expenses: 800000 },
{ quarter: "Q4", revenue: 1200000, expenses: 950000 },
],
series: [
{
type: "line",
xKey: "quarter",
yKey: "revenue",
yName: "Revenue",
},
{
type: "line",
xKey: "quarter",
yKey: "expenses",
yName: "Expenses",
},
],
});
return {
options,
};
},
});
createApp(ChartExample).mount("#app");
{
title: {
text: [
{
text: '2025',
fontStyle: 'italic',
},
{
text: ' Financial Growth ',
fontSize: 26,
},
{
text: 'Overview',
color: '#ff7f0e',
fontFamily: 'monospace',
},
],
},
}In the above example:
- Pass an array of
TextSegmentobjects, each with atextproperty and font style overrides. - The top-level font options on each element apply to all segments, unless a segment overrides them.
Label Formatters with Multi-Style Text Copy Link
Series and axis label formatters also support multiple font styles.
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
AnimationModule,
BarSeriesModule,
CategoryAxisModule,
ContextMenuModule,
CrosshairModule,
LegendModule,
ModuleRegistry,
NumberAxisModule,
} from "ag-charts-enterprise";
import { getData } from "./data";
ModuleRegistry.registerModules([
AnimationModule,
BarSeriesModule,
CategoryAxisModule,
CrosshairModule,
LegendModule,
NumberAxisModule,
ContextMenuModule,
]);
const ChartExample = defineComponent({
template: `
<ag-charts
:options="options"
/>
`,
components: {
"ag-charts": AgCharts,
},
setup(props) {
const options = ref<AgChartOptions>({
title: {
text: "Product Sales Performance",
},
subtitle: {
text: "Q4 2025 Sales vs Target",
},
data: getData(),
series: [
{
type: "bar",
xKey: "product",
yKey: "sales",
yName: "Sales",
label: {
enabled: true,
formatter: ({ value }) => {
return [
{
text: value.toString(),
fontSize: 18,
fontWeight: "bold",
color: "white",
},
{
text: "\nunits",
fontSize: 11,
color: "rgba(255, 255, 255, 0.8)",
},
];
},
},
},
],
axes: {
y: {
type: "number",
label: {
formatter: ({ value }) => {
if (value === 0) return "0";
return [
{
text: value.toString(),
fontSize: 13,
fontWeight: "bold",
},
{
text: " units",
fontSize: 10,
},
];
},
},
},
},
});
return {
options,
};
},
});
createApp(ChartExample).mount("#app");
export interface TData {
product: string;
sales: number;
target: number;
}
export function getData(): TData[] {
return [
{ product: "Laptops", sales: 145, target: 120 },
{ product: "Tablets", sales: 98, target: 100 },
{ product: "Smartphones", sales: 203, target: 180 },
{ product: "Monitors", sales: 87, target: 90 },
{ product: "Keyboards", sales: 62, target: 55 },
];
}
{
series: [
{
type: 'bar',
label: {
formatter: ({ value }) => [
{ text: value.toString(), fontSize: 18, fontWeight: 'bold', color: 'white' },
{ text: '\nunits', fontSize: 11, color: 'rgba(255, 255, 255, 0.8)' },
],
},
},
],
}In the above example:
- The formatter returns an array of
TextSegmentobjects instead of a string. - The first segment shows the value in large, bold, white text.
- The second segment displays "units" in smaller, semi-transparent text.
- Each text segment can have independent font styling (size, weight, color, style, family).
- Newline characters (
\n) separate segments across multiple lines.
Aligning Segments Vertically Copy Link
Segments share a baseline by default. Set verticalAlign: 'middle' to centre it instead.
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
BarSeriesModule,
CategoryAxisModule,
ModuleRegistry,
NumberAxisModule,
} from "ag-charts-community";
import clone from "clone";
function buildTitle(verticalAlign) {
return [
{ text: "🚀 ", fontSize: 36, verticalAlign },
{ text: "Quarterly ", fontSize: 16, verticalAlign },
{ text: "Spending ", fontSize: 28, verticalAlign },
{ text: "Growth", fontSize: 20, verticalAlign },
];
}
ModuleRegistry.registerModules([
BarSeriesModule,
CategoryAxisModule,
NumberAxisModule,
]);
const ChartExample = defineComponent({
template: `
<div class="example-controls">
<div class="controls-row">
<div class="button-group" role="group" aria-label="Vertical Align">
<input type="radio" id="vertical-align-baseline" name="text-vertical-align" value="baseline" checked="" v-on:change="setVerticalAlign($event)">
<label for="vertical-align-baseline">Baseline</label>
<input type="radio" id="vertical-align-top" name="text-vertical-align" value="top" v-on:change="setVerticalAlign($event)">
<label for="vertical-align-top">Top</label>
<input type="radio" id="vertical-align-middle" name="text-vertical-align" value="middle" v-on:change="setVerticalAlign($event)">
<label for="vertical-align-middle">Middle</label>
<input type="radio" id="vertical-align-bottom" name="text-vertical-align" value="bottom" v-on:change="setVerticalAlign($event)">
<label for="vertical-align-bottom">Bottom</label>
</div>
</div>
</div>
<ag-charts
ref="agCharts"
:options="options"
/>
`,
components: {
"ag-charts": AgCharts,
},
setup(props) {
const options = ref<AgChartOptions>({
title: {
text: buildTitle("baseline"),
fontWeight: "bold",
},
data: [
{ quarter: "Q1", sales: 120 },
{ quarter: "Q2", sales: 180 },
{ quarter: "Q3", sales: 240 },
{ quarter: "Q4", sales: 310 },
],
series: [
{
type: "bar",
xKey: "quarter",
yKey: "sales",
yName: "Sales",
},
],
});
const agCharts = ref(null);
const setVerticalAlign = (event) => {
const verticalAlign = event.target.value;
agCharts.value.chart.updateDelta({
title: { text: buildTitle(verticalAlign) },
});
};
return {
options,
agCharts,
setVerticalAlign,
};
},
});
createApp(ChartExample).mount("#app");
{
title: {
text: [
{ text: '🚀 ', fontSize: 36, verticalAlign: 'baseline' },
{ text: 'Quarterly ', fontSize: 16, verticalAlign: 'baseline' },
{ text: 'Spending ', fontSize: 28, verticalAlign: 'baseline' },
{ text: 'Growth', fontSize: 20, verticalAlign: 'baseline' },
],
},
}In this example:
- Use the buttons to align every segment in the title, moving the large and small text together.
'baseline'and'bottom'differ where text has descenders (such as thep,y, andgin the title): baseline aligns the text baselines, while bottom aligns the lowest pixel of each segment.verticalAlignapplies per segment, so a single line can also mix baseline-aligned text with centred emoji or icon glyphs.
Displaying Images and Text Copy Link
Text Segments support adding inline images using multiple approaches.
Inline Image Segments Copy Link
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
AnimationModule,
BarSeriesModule,
CategoryAxisModule,
LegendModule,
ModuleRegistry,
NumberAxisModule,
} from "ag-charts-enterprise";
import { getData } from "./data";
const flagsUrl = "https://www.ag-grid.com/charts/example-assets/flags/";
const arrowUp =
"data:image/svg+xml;utf8," +
encodeURIComponent(
'<svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 16 16"><path fill="#22c55e" d="M8 2 14 12H2z"/></svg>',
);
const arrowDown =
"data:image/svg+xml;utf8," +
encodeURIComponent(
'<svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 16 16"><path fill="#d62728" d="M8 14 2 4h12z"/></svg>',
);
ModuleRegistry.registerModules([
AnimationModule,
BarSeriesModule,
CategoryAxisModule,
LegendModule,
NumberAxisModule,
]);
const ChartExample = defineComponent({
template: `
<ag-charts
:options="options"
/>
`,
components: {
"ag-charts": AgCharts,
},
setup(props) {
const options = ref<AgChartOptions>({
title: {
text: [
{ text: "Top Markets " },
{
type: "image",
url: flagsUrl + "us.png",
width: 24,
height: 18,
verticalAlign: "middle",
},
{ text: " 2025", fontWeight: "bold" },
],
fontSize: 22,
},
subtitle: {
text: "Quarterly revenue by country",
},
data: getData(),
series: [
{
type: "bar",
xKey: "code",
yKey: "revenue",
yName: "Revenue",
label: {
enabled: true,
fill: { ref: "backgroundColor" },
color: { ref: "foregroundColor" },
formatter: ({ datum }) => {
const d = datum;
return [
{ text: `${d.revenue}M `, fontWeight: "bold" },
{
type: "image",
url: d.delta >= 0 ? arrowUp : arrowDown,
width: 12,
height: 12,
verticalAlign: "middle",
},
];
},
},
},
],
axes: {
x: {
type: "category",
label: {
formatter: ({ value }) => [
{
type: "image",
url: flagsUrl + `${value}.png`,
width: 20,
height: 15,
verticalAlign: "middle",
},
{ text: ` ${String(value).toUpperCase()}`, fontWeight: "bold" },
],
},
},
y: {
type: "number",
label: { formatter: ({ value }) => `$${value}M` },
},
},
});
return {
options,
};
},
});
createApp(ChartExample).mount("#app");
export interface TData {
code: string;
name: string;
revenue: number;
delta: number;
}
export function getData(): TData[] {
return [
{ code: "us", name: "United States", revenue: 482, delta: 18 },
{ code: "gb", name: "United Kingdom", revenue: 264, delta: -7 },
{ code: "de", name: "Germany", revenue: 318, delta: 12 },
{ code: "fr", name: "France", revenue: 197, delta: 4 },
{ code: "br", name: "Brazil", revenue: 132, delta: -3 },
];
}
Provide any image URL through the url property:
{
axes: {
x: {
type: 'category',
label: {
formatter: ({ value }) => [
{
type: 'image',
url: flagsUrl + `${value}.png`,
width: 20,
height: 15,
verticalAlign: 'middle',
},
{ text: ` ${String(value).toUpperCase()}`, fontWeight: 'bold' },
],
},
},
},
}An image segment uses type: 'image' and supports:
widthandheight- these are required.verticalAlign- vertical alignment against the text.cornerRadius,padding- for styling the image box.backgroundFill- also shows as a placeholder while the image loads or if it fails.overflowStrategy- drop priority for label collision avoidance.'hide'- images are dropped before text is truncated.'keep'images take priority, dropping trailing text first and only dropping the image if it cannot fit on its own.
Block Image Segments Copy Link
Set block: true on an image that begins a row, and the text segments that follow wrap into a column to its right instead of continuing on the same line.
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
AnimationModule,
LegendModule,
ModuleRegistry,
TreemapSeriesModule,
} from "ag-charts-enterprise";
import { getData } from "./data";
const brandIconsUrl = "https://www.ag-grid.com/charts/example-assets/brand-icons/";
ModuleRegistry.registerModules([
AnimationModule,
LegendModule,
TreemapSeriesModule,
]);
const ChartExample = defineComponent({
template: `
<ag-charts
:options="options"
/>
`,
components: {
"ag-charts": AgCharts,
},
setup(props) {
const options = ref<AgChartOptions>({
data: getData(),
series: [
{
type: "treemap",
labelKey: "name",
sizeKey: "value",
group: {
label: {
fontSize: 14,
color: "#fff",
},
},
tile: {
label: {
formatter: ({ datum }) => {
const d = datum;
return [
{
type: "image",
url: brandIconsUrl + `${d.slug}.svg`,
width: 36,
height: 36,
block: true,
padding: 6,
backgroundFill: "rgba(0, 0, 0, 0.35)",
cornerRadius: 8,
},
{ text: d.name, fontWeight: "bold", verticalAlign: "middle" },
{ text: `\n$${d.value}B`, color: "rgba(0, 0, 0, 0.6)" },
];
},
fontSize: 16,
minimumFontSize: 10,
spacing: 2,
},
secondaryLabel: { enabled: false },
},
},
],
title: { text: "Top Tech Brand Values, 2024" },
subtitle: { text: "Brand value in USD billions" },
});
return {
options,
};
},
});
createApp(ChartExample).mount("#app");
export interface TData {
name: string;
slug: string;
value: number;
}
export interface TGroup {
name: string;
children: TData[];
}
export function getData(): TGroup[] {
return [
{
name: "Hardware",
children: [
{ name: "Apple", slug: "apple", value: 383 },
{ name: "NVIDIA", slug: "nvidia", value: 244 },
{ name: "Intel", slug: "intel", value: 87 },
{ name: "Tesla", slug: "tesla", value: 67 },
],
},
{
name: "Software",
children: [
{ name: "Google", slug: "google", value: 333 },
{ name: "Meta", slug: "meta", value: 196 },
{ name: "SAP", slug: "sap", value: 58 },
{ name: "Shopify", slug: "shopify", value: 36 },
],
},
{
name: "Services",
children: [
{ name: "Netflix", slug: "netflix", value: 38 },
{ name: "Spotify", slug: "spotify", value: 21 },
{ name: "Airbnb", slug: "airbnb", value: 24 },
{ name: "Uber", slug: "uber", value: 32 },
{ name: "PayPal", slug: "paypal", value: 27 },
{ name: "Stripe", slug: "stripe", value: 14 },
],
},
];
}
{
type: 'image',
url: brandIconsUrl + `${datum.slug}.svg`,
width: 36,
height: 36,
block: true,
padding: 6,
backgroundFill: 'rgba(0, 0, 0, 0.35)',
cornerRadius: 8,
}In this example:
- The block image segment anchors to the left of its row, with the following text wrapping into a column to its right. The column can span multiple lines.
- Defaults
verticalAlignto'middle', centring the image against the text column beside it. - Is dropped when its row has no space for it, leaving the text to use the full width. This is controlled by the
overflowStrategyoption.
Emojis and Font Icons Copy Link
Emojis and font icons render through native canvas, with no API changes required. Both can be mixed freely with text within a single element.
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
AnimationModule,
BarSeriesModule,
CategoryAxisModule,
LegendModule,
ModuleRegistry,
NumberAxisModule,
} from "ag-charts-enterprise";
import { getData } from "./data";
const data = getData();
// Keycap number emoji (U+0031..U+0035 + U+FE0F + U+20E3) rank each country by position.
const rankEmoji = ["1️⃣", "2️⃣", "3️⃣", "4️⃣", "5️⃣"];
const rankByCountry = new Map(data.map((d, i) => [d.country, rankEmoji[i]]));
const ICON_FAMILY_SOLID = "Font Awesome 6 Free";
const SOLID_WEIGHT = 900;
const ICON_CHART_LINE = "";
const ICON_STAR = "";
ModuleRegistry.registerModules([
AnimationModule,
BarSeriesModule,
CategoryAxisModule,
LegendModule,
NumberAxisModule,
]);
const ChartExample = defineComponent({
template: `
<ag-charts
:options="options"
/>
`,
components: {
"ag-charts": AgCharts,
},
setup(props) {
const options = ref<AgChartOptions>({
title: {
text: [
{
text: `${ICON_CHART_LINE} `,
fontFamily: ICON_FAMILY_SOLID,
fontWeight: SOLID_WEIGHT,
color: "#1f77b4",
verticalAlign: "middle",
},
{ text: "Top Markets 2025", fontWeight: "bold" },
{
text: ` ${ICON_STAR}`,
fontFamily: ICON_FAMILY_SOLID,
fontWeight: SOLID_WEIGHT,
color: "#f1c40f",
verticalAlign: "middle",
},
],
fontSize: 22,
},
subtitle: {
text: [
{
text: `${ICON_CHART_LINE} `,
fontFamily: ICON_FAMILY_SOLID,
fontWeight: SOLID_WEIGHT,
color: "#1f77b4",
verticalAlign: "middle",
},
{ text: "Quarterly revenue by country" },
],
},
data,
series: [
{
type: "bar",
xKey: "country",
yKey: "revenue",
yName: "Revenue",
label: {
enabled: true,
formatter: ({ datum }) => `${datum.revenue}M`,
},
},
],
axes: {
x: {
type: "category",
label: {
formatter: ({ value }) => [
{
text: `${rankByCountry.get(String(value)) ?? ""} `,
fontSize: 18,
verticalAlign: "middle",
},
{
text: String(value),
fontWeight: "bold",
verticalAlign: "middle",
},
],
},
},
y: {
type: "number",
label: { formatter: ({ value }) => `$${value}M` },
},
},
});
return {
options,
};
},
});
createApp(ChartExample).mount("#app");
export interface TData {
country: string;
revenue: number;
delta: number;
}
export function getData(): TData[] {
return [
{ country: "US", revenue: 482, delta: 18 },
{ country: "GB", revenue: 264, delta: -7 },
{ country: "DE", revenue: 318, delta: 12 },
{ country: "JP", revenue: 197, delta: 4 },
{ country: "BR", revenue: 132, delta: -3 },
];
}
In this example:
- The axis labels use number emojis within the
textproperty of aTextSegmentobject. - The title uses a FontAwesome glyph to add a chart icon and a star.
- Font icons set the icon font with
fontFamilyandfontWeighton the segment and use the icon's glyph as thetext. - They are loaded via CSS, with the chart downloading any referenced fonts and re-rendering once they are ready.
- Font icons set the icon font with
{
axes: {
x: {
type: 'category',
label: {
formatter: ({ value }) => [
{ text: '1️⃣ ', fontSize: 18, verticalAlign: 'middle' },
{ text: String(value), fontWeight: 'bold', verticalAlign: 'middle' },
],
},
},
},
}{
title: {
text: [
{
text: `${ICON_CHART_LINE} `,
fontFamily: ICON_FAMILY_SOLID,
fontWeight: SOLID_WEIGHT,
color: '#1f77b4',
verticalAlign: 'middle',
},
{ text: 'Top Markets 2025', fontWeight: 'bold' },
{
text: ` ${ICON_STAR}`,
fontFamily: ICON_FAMILY_SOLID,
fontWeight: SOLID_WEIGHT,
color: '#f1c40f',
verticalAlign: 'middle',
},
],
fontSize: 22,
},
} API Reference Copy Link
See API Options for the full list of font options on each chart element.

This section describes how to style the text used throughout a chart, including titles, labels and other elements. It covers font options, applying multiple font styles and inline images within a single text element.
Fonts Copy Link
Each chart element has font options, including fontFamily, fontSize and fontWeight. The font options for the whole chart can be set once using theme parameters.
Font Families Copy Link
Font families can accept the following value types:
| Syntax | Description |
|---|---|
string | A CSS font-family value, such as 'Arial, sans-serif'. |
{ googleFont: 'IBM Plex Sans' } | A Google font. You must load the font or ask the chart to load it for you, see Google Fonts below. |
['Arial', 'sans-serif'] | An array of fonts. Each item can be a string font name or a { googleFont: "..." } object. The browser will attempt to use the first font and fall back to later fonts if the first one fails to load or is not available on the host system. |
Google Fonts Copy Link
import { Component } from "@angular/core";
import { AgCharts } from "ag-charts-angular";
import {
AgChartOptions,
AnimationModule,
CategoryAxisModule,
ContextMenuModule,
CrosshairModule,
LegendModule,
LineSeriesModule,
ModuleRegistry,
NumberAxisModule,
} from "ag-charts-enterprise";
ModuleRegistry.registerModules([
AnimationModule,
CategoryAxisModule,
CrosshairModule,
LegendModule,
LineSeriesModule,
NumberAxisModule,
ContextMenuModule,
]);
@Component({
selector: "my-app",
standalone: true,
imports: [AgCharts],
template: `<ag-charts
[options]="options"
></ag-charts>
`,
})
export class AppComponent {
public options;
constructor() {
this.options = {
title: {
text: "Title in Pacifico",
fontFamily: { googleFont: "Pacifico" },
fontSize: 25,
maxHeight: 50,
},
subtitle: {
text: "Subtitle in DM Serif Text",
fontFamily: [{ googleFont: "DM Serif Text" }, "monospace"],
fontSize: 18,
},
data: [
{ month: "Jan", avgTemp: 2.3, iceCreamSales: 162000 },
{ month: "Mar", avgTemp: 6.3, iceCreamSales: 302000 },
{ month: "May", avgTemp: 16.2, iceCreamSales: 800000 },
{ month: "Jul", avgTemp: 22.8, iceCreamSales: 1254000 },
{ month: "Sep", avgTemp: 14.5, iceCreamSales: 950000 },
{ month: "Nov", avgTemp: 8.9, iceCreamSales: 200000 },
],
series: [
{
type: "line",
xKey: "month",
yKey: "iceCreamSales",
yName: "Ice Cream Sales",
},
],
axes: {
y: {
type: "number",
label: { fontFamily: ["Helvetica", "Arial", "sans-serif"] },
},
x: {
type: "category",
label: {
fontFamily: { googleFont: "Orbitron" },
fontSize: 12,
},
},
},
loadGoogleFonts: true,
};
}
}
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent);
To prevent potential licensing and privacy implications, the chart will not load Google fonts unless requested to.
If you want to use Google fonts, you should either:
- Set the chart's
loadGoogleFontsoption totrueand use the{ googleFont: "..." }object for the chart to load the font from Google's CDN. - Load the font yourself using a
@font-facerule in your application's CSS.
If the font has not been loaded through either of the above methods, the theme will fall back to the most appropriate font available on the system.
In the above example:
- The
loadGoogleFontsoption is set totrueto automatically load Google fonts. - The title uses the Google font
Pacifico. - The subtitle uses the Google font
DM Serif Textwith a fallback tomonospace. - The left axis uses the local system font
Helveticawith a fallback toArialthensans-serif. - The bottom axis uses the Google font
Orbitron.
Multi-Style Text Elements Copy Link
The chart title, subtitle and footnote support multiple font styles within one element.
import { Component } from "@angular/core";
import { AgCharts } from "ag-charts-angular";
import {
AgChartOptions,
AnimationModule,
CategoryAxisModule,
ContextMenuModule,
CrosshairModule,
LegendModule,
LineSeriesModule,
ModuleRegistry,
NumberAxisModule,
} from "ag-charts-enterprise";
ModuleRegistry.registerModules([
AnimationModule,
CategoryAxisModule,
CrosshairModule,
LegendModule,
LineSeriesModule,
NumberAxisModule,
ContextMenuModule,
]);
@Component({
selector: "my-app",
standalone: true,
imports: [AgCharts],
template: `<ag-charts
[options]="options"
></ag-charts>
`,
})
export class AppComponent {
public options;
constructor() {
this.options = {
title: {
text: [
{
text: "2025",
fontStyle: "italic",
},
{
text: " Financial Growth ",
fontSize: 26,
},
{
text: "Overview",
color: "#ff7f0e",
fontFamily: "monospace",
},
],
color: "#1f77b4",
fontSize: 34,
fontWeight: "bold",
},
subtitle: {
text: [
{ text: "Quarterly Revenue vs Expenses Analysis", color: "#2ca02c" },
{ text: " for Q1 & Q2 2025", color: "#d62728" },
],
fontSize: 18,
fontWeight: "bold",
},
footnote: {
text: [
{ text: "All of this " },
{ text: "data is fictitious", fontWeight: "bold", fontSize: 15 },
{ text: " and for example purposes only." },
],
},
data: [
{ quarter: "Q1", revenue: 500000, expenses: 450000 },
{ quarter: "Q2", revenue: 750000, expenses: 600000 },
{ quarter: "Q3", revenue: 1000000, expenses: 800000 },
{ quarter: "Q4", revenue: 1200000, expenses: 950000 },
],
series: [
{
type: "line",
xKey: "quarter",
yKey: "revenue",
yName: "Revenue",
},
{
type: "line",
xKey: "quarter",
yKey: "expenses",
yName: "Expenses",
},
],
};
}
}
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent);
{
title: {
text: [
{
text: '2025',
fontStyle: 'italic',
},
{
text: ' Financial Growth ',
fontSize: 26,
},
{
text: 'Overview',
color: '#ff7f0e',
fontFamily: 'monospace',
},
],
},
}In the above example:
- Pass an array of
TextSegmentobjects, each with atextproperty and font style overrides. - The top-level font options on each element apply to all segments, unless a segment overrides them.
Label Formatters with Multi-Style Text Copy Link
Series and axis label formatters also support multiple font styles.
import { Component } from "@angular/core";
import { AgCharts } from "ag-charts-angular";
import {
AgChartOptions,
AnimationModule,
BarSeriesModule,
CategoryAxisModule,
ContextMenuModule,
CrosshairModule,
LegendModule,
ModuleRegistry,
NumberAxisModule,
} from "ag-charts-enterprise";
import { getData } from "./data";
ModuleRegistry.registerModules([
AnimationModule,
BarSeriesModule,
CategoryAxisModule,
CrosshairModule,
LegendModule,
NumberAxisModule,
ContextMenuModule,
]);
@Component({
selector: "my-app",
standalone: true,
imports: [AgCharts],
template: `<ag-charts
[options]="options"
></ag-charts>
`,
})
export class AppComponent {
public options;
constructor() {
this.options = {
title: {
text: "Product Sales Performance",
},
subtitle: {
text: "Q4 2025 Sales vs Target",
},
data: getData(),
series: [
{
type: "bar",
xKey: "product",
yKey: "sales",
yName: "Sales",
label: {
enabled: true,
formatter: ({ value }) => {
return [
{
text: value.toString(),
fontSize: 18,
fontWeight: "bold",
color: "white",
},
{
text: "\nunits",
fontSize: 11,
color: "rgba(255, 255, 255, 0.8)",
},
];
},
},
},
],
axes: {
y: {
type: "number",
label: {
formatter: ({ value }) => {
if (value === 0) return "0";
return [
{
text: value.toString(),
fontSize: 13,
fontWeight: "bold",
},
{
text: " units",
fontSize: 10,
},
];
},
},
},
},
};
}
}
export interface TData {
product: string;
sales: number;
target: number;
}
export function getData(): TData[] {
return [
{ product: "Laptops", sales: 145, target: 120 },
{ product: "Tablets", sales: 98, target: 100 },
{ product: "Smartphones", sales: 203, target: 180 },
{ product: "Monitors", sales: 87, target: 90 },
{ product: "Keyboards", sales: 62, target: 55 },
];
}
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent);
{
series: [
{
type: 'bar',
label: {
formatter: ({ value }) => [
{ text: value.toString(), fontSize: 18, fontWeight: 'bold', color: 'white' },
{ text: '\nunits', fontSize: 11, color: 'rgba(255, 255, 255, 0.8)' },
],
},
},
],
}In the above example:
- The formatter returns an array of
TextSegmentobjects instead of a string. - The first segment shows the value in large, bold, white text.
- The second segment displays "units" in smaller, semi-transparent text.
- Each text segment can have independent font styling (size, weight, color, style, family).
- Newline characters (
\n) separate segments across multiple lines.
Aligning Segments Vertically Copy Link
Segments share a baseline by default. Set verticalAlign: 'middle' to centre it instead.
import { Component, ViewChild } from "@angular/core";
import { AgCharts } from "ag-charts-angular";
import {
AgChartOptions,
BarSeriesModule,
CategoryAxisModule,
ModuleRegistry,
NumberAxisModule,
} from "ag-charts-community";
import clone from "clone";
function buildTitle(verticalAlign: "baseline" | "top" | "middle" | "bottom") {
return [
{ text: "🚀 ", fontSize: 36, verticalAlign },
{ text: "Quarterly ", fontSize: 16, verticalAlign },
{ text: "Spending ", fontSize: 28, verticalAlign },
{ text: "Growth", fontSize: 20, verticalAlign },
];
}
ModuleRegistry.registerModules([
BarSeriesModule,
CategoryAxisModule,
NumberAxisModule,
]);
@Component({
selector: "my-app",
standalone: true,
imports: [AgCharts],
template: `<div class="example-controls">
<div class="controls-row">
<div class="button-group" role="group" aria-label="Vertical Align">
<input type="radio" id="vertical-align-baseline" name="text-vertical-align" value="baseline" checked="" (change)="setVerticalAlign($event)">
<label for="vertical-align-baseline">Baseline</label>
<input type="radio" id="vertical-align-top" name="text-vertical-align" value="top" (change)="setVerticalAlign($event)">
<label for="vertical-align-top">Top</label>
<input type="radio" id="vertical-align-middle" name="text-vertical-align" value="middle" (change)="setVerticalAlign($event)">
<label for="vertical-align-middle">Middle</label>
<input type="radio" id="vertical-align-bottom" name="text-vertical-align" value="bottom" (change)="setVerticalAlign($event)">
<label for="vertical-align-bottom">Bottom</label>
</div>
</div>
</div>
<ag-charts
[options]="options"
></ag-charts>
`,
})
export class AppComponent {
public options;
@ViewChild(AgCharts)
public agCharts!: AgCharts;
constructor() {
this.options = {
title: {
text: buildTitle("baseline"),
fontWeight: "bold",
},
data: [
{ quarter: "Q1", sales: 120 },
{ quarter: "Q2", sales: 180 },
{ quarter: "Q3", sales: 240 },
{ quarter: "Q4", sales: 310 },
],
series: [
{
type: "bar",
xKey: "quarter",
yKey: "sales",
yName: "Sales",
},
],
};
}
setVerticalAlign = (event: Event) => {
const verticalAlign = (event.target as HTMLInputElement).value as
| "baseline"
| "top"
| "middle"
| "bottom";
this.agCharts.chart!.updateDelta({
title: { text: buildTitle(verticalAlign) },
});
};
}
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent);
{
title: {
text: [
{ text: '🚀 ', fontSize: 36, verticalAlign: 'baseline' },
{ text: 'Quarterly ', fontSize: 16, verticalAlign: 'baseline' },
{ text: 'Spending ', fontSize: 28, verticalAlign: 'baseline' },
{ text: 'Growth', fontSize: 20, verticalAlign: 'baseline' },
],
},
}In this example:
- Use the buttons to align every segment in the title, moving the large and small text together.
'baseline'and'bottom'differ where text has descenders (such as thep,y, andgin the title): baseline aligns the text baselines, while bottom aligns the lowest pixel of each segment.verticalAlignapplies per segment, so a single line can also mix baseline-aligned text with centred emoji or icon glyphs.
Displaying Images and Text Copy Link
Text Segments support adding inline images using multiple approaches.
Inline Image Segments Copy Link
import { Component } from "@angular/core";
import { AgCharts } from "ag-charts-angular";
import {
AgChartOptions,
AnimationModule,
BarSeriesModule,
CategoryAxisModule,
LegendModule,
ModuleRegistry,
NumberAxisModule,
} from "ag-charts-enterprise";
import { TData, getData } from "./data";
const flagsUrl = "https://www.ag-grid.com/charts/example-assets/flags/";
const arrowUp =
"data:image/svg+xml;utf8," +
encodeURIComponent(
'<svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 16 16"><path fill="#22c55e" d="M8 2 14 12H2z"/></svg>',
);
const arrowDown =
"data:image/svg+xml;utf8," +
encodeURIComponent(
'<svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 16 16"><path fill="#d62728" d="M8 14 2 4h12z"/></svg>',
);
ModuleRegistry.registerModules([
AnimationModule,
BarSeriesModule,
CategoryAxisModule,
LegendModule,
NumberAxisModule,
]);
@Component({
selector: "my-app",
standalone: true,
imports: [AgCharts],
template: `<ag-charts
[options]="options"
></ag-charts>
`,
})
export class AppComponent {
public options;
constructor() {
this.options = {
title: {
text: [
{ text: "Top Markets " },
{
type: "image",
url: flagsUrl + "us.png",
width: 24,
height: 18,
verticalAlign: "middle",
},
{ text: " 2025", fontWeight: "bold" },
],
fontSize: 22,
},
subtitle: {
text: "Quarterly revenue by country",
},
data: getData(),
series: [
{
type: "bar",
xKey: "code",
yKey: "revenue",
yName: "Revenue",
label: {
enabled: true,
fill: { ref: "backgroundColor" } as any,
color: { ref: "foregroundColor" },
formatter: ({ datum }) => {
const d = datum as TData;
return [
{ text: `${d.revenue}M `, fontWeight: "bold" },
{
type: "image",
url: d.delta >= 0 ? arrowUp : arrowDown,
width: 12,
height: 12,
verticalAlign: "middle",
},
];
},
},
},
],
axes: {
x: {
type: "category",
label: {
formatter: ({ value }) => [
{
type: "image",
url: flagsUrl + `${value}.png`,
width: 20,
height: 15,
verticalAlign: "middle",
},
{ text: ` ${String(value).toUpperCase()}`, fontWeight: "bold" },
],
},
},
y: {
type: "number",
label: { formatter: ({ value }) => `$${value}M` },
},
},
};
}
}
export interface TData {
code: string;
name: string;
revenue: number;
delta: number;
}
export function getData(): TData[] {
return [
{ code: "us", name: "United States", revenue: 482, delta: 18 },
{ code: "gb", name: "United Kingdom", revenue: 264, delta: -7 },
{ code: "de", name: "Germany", revenue: 318, delta: 12 },
{ code: "fr", name: "France", revenue: 197, delta: 4 },
{ code: "br", name: "Brazil", revenue: 132, delta: -3 },
];
}
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent);
Provide any image URL through the url property:
{
axes: {
x: {
type: 'category',
label: {
formatter: ({ value }) => [
{
type: 'image',
url: flagsUrl + `${value}.png`,
width: 20,
height: 15,
verticalAlign: 'middle',
},
{ text: ` ${String(value).toUpperCase()}`, fontWeight: 'bold' },
],
},
},
},
}An image segment uses type: 'image' and supports:
widthandheight- these are required.verticalAlign- vertical alignment against the text.cornerRadius,padding- for styling the image box.backgroundFill- also shows as a placeholder while the image loads or if it fails.overflowStrategy- drop priority for label collision avoidance.'hide'- images are dropped before text is truncated.'keep'images take priority, dropping trailing text first and only dropping the image if it cannot fit on its own.
Block Image Segments Copy Link
Set block: true on an image that begins a row, and the text segments that follow wrap into a column to its right instead of continuing on the same line.
import { Component } from "@angular/core";
import { AgCharts } from "ag-charts-angular";
import {
AgChartOptions,
AnimationModule,
LegendModule,
ModuleRegistry,
TreemapSeriesModule,
} from "ag-charts-enterprise";
import { TData, getData } from "./data";
const brandIconsUrl = "https://www.ag-grid.com/charts/example-assets/brand-icons/";
ModuleRegistry.registerModules([
AnimationModule,
LegendModule,
TreemapSeriesModule,
]);
@Component({
selector: "my-app",
standalone: true,
imports: [AgCharts],
template: `<ag-charts
[options]="options"
></ag-charts>
`,
})
export class AppComponent {
public options;
constructor() {
this.options = {
data: getData(),
series: [
{
type: "treemap",
labelKey: "name",
sizeKey: "value",
group: {
label: {
fontSize: 14,
color: "#fff",
},
},
tile: {
label: {
formatter: ({ datum }) => {
const d = datum as TData;
return [
{
type: "image",
url: brandIconsUrl + `${d.slug}.svg`,
width: 36,
height: 36,
block: true,
padding: 6,
backgroundFill: "rgba(0, 0, 0, 0.35)",
cornerRadius: 8,
},
{ text: d.name, fontWeight: "bold", verticalAlign: "middle" },
{ text: `\n$${d.value}B`, color: "rgba(0, 0, 0, 0.6)" },
];
},
fontSize: 16,
minimumFontSize: 10,
spacing: 2,
},
secondaryLabel: { enabled: false },
},
},
],
title: { text: "Top Tech Brand Values, 2024" },
subtitle: { text: "Brand value in USD billions" },
};
}
}
export interface TData {
name: string;
slug: string;
value: number;
}
export interface TGroup {
name: string;
children: TData[];
}
export function getData(): TGroup[] {
return [
{
name: "Hardware",
children: [
{ name: "Apple", slug: "apple", value: 383 },
{ name: "NVIDIA", slug: "nvidia", value: 244 },
{ name: "Intel", slug: "intel", value: 87 },
{ name: "Tesla", slug: "tesla", value: 67 },
],
},
{
name: "Software",
children: [
{ name: "Google", slug: "google", value: 333 },
{ name: "Meta", slug: "meta", value: 196 },
{ name: "SAP", slug: "sap", value: 58 },
{ name: "Shopify", slug: "shopify", value: 36 },
],
},
{
name: "Services",
children: [
{ name: "Netflix", slug: "netflix", value: 38 },
{ name: "Spotify", slug: "spotify", value: 21 },
{ name: "Airbnb", slug: "airbnb", value: 24 },
{ name: "Uber", slug: "uber", value: 32 },
{ name: "PayPal", slug: "paypal", value: 27 },
{ name: "Stripe", slug: "stripe", value: 14 },
],
},
];
}
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent);
{
type: 'image',
url: brandIconsUrl + `${datum.slug}.svg`,
width: 36,
height: 36,
block: true,
padding: 6,
backgroundFill: 'rgba(0, 0, 0, 0.35)',
cornerRadius: 8,
}In this example:
- The block image segment anchors to the left of its row, with the following text wrapping into a column to its right. The column can span multiple lines.
- Defaults
verticalAlignto'middle', centring the image against the text column beside it. - Is dropped when its row has no space for it, leaving the text to use the full width. This is controlled by the
overflowStrategyoption.
Emojis and Font Icons Copy Link
Emojis and font icons render through native canvas, with no API changes required. Both can be mixed freely with text within a single element.
import { Component } from "@angular/core";
import { AgCharts } from "ag-charts-angular";
import {
AgChartOptions,
AnimationModule,
BarSeriesModule,
CategoryAxisModule,
LegendModule,
ModuleRegistry,
NumberAxisModule,
} from "ag-charts-enterprise";
import { TData, getData } from "./data";
const data = getData();
// Keycap number emoji (U+0031..U+0035 + U+FE0F + U+20E3) rank each country by position.
const rankEmoji = ["1️⃣", "2️⃣", "3️⃣", "4️⃣", "5️⃣"];
const rankByCountry = new Map(data.map((d, i) => [d.country, rankEmoji[i]]));
const ICON_FAMILY_SOLID = "Font Awesome 6 Free";
const SOLID_WEIGHT = 900;
const ICON_CHART_LINE = "";
const ICON_STAR = "";
ModuleRegistry.registerModules([
AnimationModule,
BarSeriesModule,
CategoryAxisModule,
LegendModule,
NumberAxisModule,
]);
@Component({
selector: "my-app",
standalone: true,
imports: [AgCharts],
template: `<ag-charts
[options]="options"
></ag-charts>
`,
})
export class AppComponent {
public options;
constructor() {
this.options = {
title: {
text: [
{
text: `${ICON_CHART_LINE} `,
fontFamily: ICON_FAMILY_SOLID,
fontWeight: SOLID_WEIGHT,
color: "#1f77b4",
verticalAlign: "middle",
},
{ text: "Top Markets 2025", fontWeight: "bold" },
{
text: ` ${ICON_STAR}`,
fontFamily: ICON_FAMILY_SOLID,
fontWeight: SOLID_WEIGHT,
color: "#f1c40f",
verticalAlign: "middle",
},
],
fontSize: 22,
},
subtitle: {
text: [
{
text: `${ICON_CHART_LINE} `,
fontFamily: ICON_FAMILY_SOLID,
fontWeight: SOLID_WEIGHT,
color: "#1f77b4",
verticalAlign: "middle",
},
{ text: "Quarterly revenue by country" },
],
},
data,
series: [
{
type: "bar",
xKey: "country",
yKey: "revenue",
yName: "Revenue",
label: {
enabled: true,
formatter: ({ datum }) => `${(datum as TData).revenue}M`,
},
},
],
axes: {
x: {
type: "category",
label: {
formatter: ({ value }) => [
{
text: `${rankByCountry.get(String(value)) ?? ""} `,
fontSize: 18,
verticalAlign: "middle",
},
{
text: String(value),
fontWeight: "bold",
verticalAlign: "middle",
},
],
},
},
y: {
type: "number",
label: { formatter: ({ value }) => `$${value}M` },
},
},
};
}
}
export interface TData {
country: string;
revenue: number;
delta: number;
}
export function getData(): TData[] {
return [
{ country: "US", revenue: 482, delta: 18 },
{ country: "GB", revenue: 264, delta: -7 },
{ country: "DE", revenue: 318, delta: 12 },
{ country: "JP", revenue: 197, delta: 4 },
{ country: "BR", revenue: 132, delta: -3 },
];
}
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent);
In this example:
- The axis labels use number emojis within the
textproperty of aTextSegmentobject. - The title uses a FontAwesome glyph to add a chart icon and a star.
- Font icons set the icon font with
fontFamilyandfontWeighton the segment and use the icon's glyph as thetext. - They are loaded via CSS, with the chart downloading any referenced fonts and re-rendering once they are ready.
- Font icons set the icon font with
{
axes: {
x: {
type: 'category',
label: {
formatter: ({ value }) => [
{ text: '1️⃣ ', fontSize: 18, verticalAlign: 'middle' },
{ text: String(value), fontWeight: 'bold', verticalAlign: 'middle' },
],
},
},
},
}{
title: {
text: [
{
text: `${ICON_CHART_LINE} `,
fontFamily: ICON_FAMILY_SOLID,
fontWeight: SOLID_WEIGHT,
color: '#1f77b4',
verticalAlign: 'middle',
},
{ text: 'Top Markets 2025', fontWeight: 'bold' },
{
text: ` ${ICON_STAR}`,
fontFamily: ICON_FAMILY_SOLID,
fontWeight: SOLID_WEIGHT,
color: '#f1c40f',
verticalAlign: 'middle',
},
],
fontSize: 22,
},
} API Reference Copy Link
See API Options for the full list of font options on each chart element.

This section describes how to style the text used throughout a chart, including titles, labels and other elements. It covers font options, applying multiple font styles and inline images within a single text element.
Fonts Copy Link
Each chart element has font options, including fontFamily, fontSize and fontWeight. The font options for the whole chart can be set once using theme parameters.
Font Families Copy Link
Font families can accept the following value types:
| Syntax | Description |
|---|---|
string | A CSS font-family value, such as 'Arial, sans-serif'. |
{ googleFont: 'IBM Plex Sans' } | A Google font. You must load the font or ask the chart to load it for you, see Google Fonts below. |
['Arial', 'sans-serif'] | An array of fonts. Each item can be a string font name or a { googleFont: "..." } object. The browser will attempt to use the first font and fall back to later fonts if the first one fails to load or is not available on the host system. |
Google Fonts Copy Link
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
AgChartOptions,
AnimationModule,
CategoryAxisModule,
ContextMenuModule,
CrosshairModule,
LegendModule,
LineSeriesModule,
ModuleRegistry,
NumberAxisModule,
} from "ag-charts-enterprise";
ModuleRegistry.registerModules([
AnimationModule,
CategoryAxisModule,
CrosshairModule,
LegendModule,
LineSeriesModule,
NumberAxisModule,
ContextMenuModule,
]);
const ChartExample = () => {
const [options, setOptions] = useState<AgChartOptions>({
title: {
text: "Title in Pacifico",
fontFamily: { googleFont: "Pacifico" },
fontSize: 25,
maxHeight: 50,
},
subtitle: {
text: "Subtitle in DM Serif Text",
fontFamily: [{ googleFont: "DM Serif Text" }, "monospace"],
fontSize: 18,
},
data: [
{ month: "Jan", avgTemp: 2.3, iceCreamSales: 162000 },
{ month: "Mar", avgTemp: 6.3, iceCreamSales: 302000 },
{ month: "May", avgTemp: 16.2, iceCreamSales: 800000 },
{ month: "Jul", avgTemp: 22.8, iceCreamSales: 1254000 },
{ month: "Sep", avgTemp: 14.5, iceCreamSales: 950000 },
{ month: "Nov", avgTemp: 8.9, iceCreamSales: 200000 },
],
series: [
{
type: "line",
xKey: "month",
yKey: "iceCreamSales",
yName: "Ice Cream Sales",
},
],
axes: {
y: {
type: "number",
label: { fontFamily: ["Helvetica", "Arial", "sans-serif"] },
},
x: {
type: "category",
label: {
fontFamily: { googleFont: "Orbitron" },
fontSize: 12,
},
},
},
loadGoogleFonts: true,
});
return <AgCharts options={options} />;
};
const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
To prevent potential licensing and privacy implications, the chart will not load Google fonts unless requested to.
If you want to use Google fonts, you should either:
- Set the chart's
loadGoogleFontsoption totrueand use the{ googleFont: "..." }object for the chart to load the font from Google's CDN. - Load the font yourself using a
@font-facerule in your application's CSS.
If the font has not been loaded through either of the above methods, the theme will fall back to the most appropriate font available on the system.
In the above example:
- The
loadGoogleFontsoption is set totrueto automatically load Google fonts. - The title uses the Google font
Pacifico. - The subtitle uses the Google font
DM Serif Textwith a fallback tomonospace. - The left axis uses the local system font
Helveticawith a fallback toArialthensans-serif. - The bottom axis uses the Google font
Orbitron.
Multi-Style Text Elements Copy Link
The chart title, subtitle and footnote support multiple font styles within one element.
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
AgChartOptions,
AnimationModule,
CategoryAxisModule,
ContextMenuModule,
CrosshairModule,
LegendModule,
LineSeriesModule,
ModuleRegistry,
NumberAxisModule,
} from "ag-charts-enterprise";
ModuleRegistry.registerModules([
AnimationModule,
CategoryAxisModule,
CrosshairModule,
LegendModule,
LineSeriesModule,
NumberAxisModule,
ContextMenuModule,
]);
const ChartExample = () => {
const [options, setOptions] = useState<AgChartOptions>({
title: {
text: [
{
text: "2025",
fontStyle: "italic",
},
{
text: " Financial Growth ",
fontSize: 26,
},
{
text: "Overview",
color: "#ff7f0e",
fontFamily: "monospace",
},
],
color: "#1f77b4",
fontSize: 34,
fontWeight: "bold",
},
subtitle: {
text: [
{ text: "Quarterly Revenue vs Expenses Analysis", color: "#2ca02c" },
{ text: " for Q1 & Q2 2025", color: "#d62728" },
],
fontSize: 18,
fontWeight: "bold",
},
footnote: {
text: [
{ text: "All of this " },
{ text: "data is fictitious", fontWeight: "bold", fontSize: 15 },
{ text: " and for example purposes only." },
],
},
data: [
{ quarter: "Q1", revenue: 500000, expenses: 450000 },
{ quarter: "Q2", revenue: 750000, expenses: 600000 },
{ quarter: "Q3", revenue: 1000000, expenses: 800000 },
{ quarter: "Q4", revenue: 1200000, expenses: 950000 },
],
series: [
{
type: "line",
xKey: "quarter",
yKey: "revenue",
yName: "Revenue",
},
{
type: "line",
xKey: "quarter",
yKey: "expenses",
yName: "Expenses",
},
],
});
return <AgCharts options={options} />;
};
const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
{
title: {
text: [
{
text: '2025',
fontStyle: 'italic',
},
{
text: ' Financial Growth ',
fontSize: 26,
},
{
text: 'Overview',
color: '#ff7f0e',
fontFamily: 'monospace',
},
],
},
}In the above example:
- Pass an array of
TextSegmentobjects, each with atextproperty and font style overrides. - The top-level font options on each element apply to all segments, unless a segment overrides them.
Label Formatters with Multi-Style Text Copy Link
Series and axis label formatters also support multiple font styles.
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
AgChartOptions,
AnimationModule,
BarSeriesModule,
CategoryAxisModule,
ContextMenuModule,
CrosshairModule,
LegendModule,
ModuleRegistry,
NumberAxisModule,
} from "ag-charts-enterprise";
import { getData } from "./data";
ModuleRegistry.registerModules([
AnimationModule,
BarSeriesModule,
CategoryAxisModule,
CrosshairModule,
LegendModule,
NumberAxisModule,
ContextMenuModule,
]);
const ChartExample = () => {
const [options, setOptions] = useState<AgChartOptions>({
title: {
text: "Product Sales Performance",
},
subtitle: {
text: "Q4 2025 Sales vs Target",
},
data: getData(),
series: [
{
type: "bar",
xKey: "product",
yKey: "sales",
yName: "Sales",
label: {
enabled: true,
formatter: ({ value }) => {
return [
{
text: value.toString(),
fontSize: 18,
fontWeight: "bold",
color: "white",
},
{
text: "\nunits",
fontSize: 11,
color: "rgba(255, 255, 255, 0.8)",
},
];
},
},
},
],
axes: {
y: {
type: "number",
label: {
formatter: ({ value }) => {
if (value === 0) return "0";
return [
{
text: value.toString(),
fontSize: 13,
fontWeight: "bold",
},
{
text: " units",
fontSize: 10,
},
];
},
},
},
},
});
return <AgCharts options={options} />;
};
const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
export interface TData {
product: string;
sales: number;
target: number;
}
export function getData(): TData[] {
return [
{ product: "Laptops", sales: 145, target: 120 },
{ product: "Tablets", sales: 98, target: 100 },
{ product: "Smartphones", sales: 203, target: 180 },
{ product: "Monitors", sales: 87, target: 90 },
{ product: "Keyboards", sales: 62, target: 55 },
];
}
{
series: [
{
type: 'bar',
label: {
formatter: ({ value }) => [
{ text: value.toString(), fontSize: 18, fontWeight: 'bold', color: 'white' },
{ text: '\nunits', fontSize: 11, color: 'rgba(255, 255, 255, 0.8)' },
],
},
},
],
}In the above example:
- The formatter returns an array of
TextSegmentobjects instead of a string. - The first segment shows the value in large, bold, white text.
- The second segment displays "units" in smaller, semi-transparent text.
- Each text segment can have independent font styling (size, weight, color, style, family).
- Newline characters (
\n) separate segments across multiple lines.
Aligning Segments Vertically Copy Link
Segments share a baseline by default. Set verticalAlign: 'middle' to centre it instead.
import React, { useState, useRef, Fragment } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
AgChartOptions,
AgChartsInstance,
BarSeriesModule,
CategoryAxisModule,
ModuleRegistry,
NumberAxisModule,
} from "ag-charts-community";
import clone from "clone";
function buildTitle(verticalAlign: "baseline" | "top" | "middle" | "bottom") {
return [
{ text: "🚀 ", fontSize: 36, verticalAlign },
{ text: "Quarterly ", fontSize: 16, verticalAlign },
{ text: "Spending ", fontSize: 28, verticalAlign },
{ text: "Growth", fontSize: 20, verticalAlign },
];
}
ModuleRegistry.registerModules([
BarSeriesModule,
CategoryAxisModule,
NumberAxisModule,
]);
const ChartExample = () => {
const chartRef = useRef<AgChartsInstance>(null);
const [options, setOptions] = useState<AgChartOptions>({
title: {
text: buildTitle("baseline"),
fontWeight: "bold",
},
data: [
{ quarter: "Q1", sales: 120 },
{ quarter: "Q2", sales: 180 },
{ quarter: "Q3", sales: 240 },
{ quarter: "Q4", sales: 310 },
],
series: [
{
type: "bar",
xKey: "quarter",
yKey: "sales",
yName: "Sales",
},
],
});
const setVerticalAlign = (event: Event) => {
const verticalAlign = (event.target as HTMLInputElement).value as
| "baseline"
| "top"
| "middle"
| "bottom";
chartRef.current!.updateDelta({
title: { text: buildTitle(verticalAlign) },
});
};
return (
<Fragment>
<div className="example-controls">
<div className="controls-row">
<div
className="button-group"
role="group"
aria-label="Vertical Align"
>
<input
type="radio"
id="vertical-align-baseline"
name="text-vertical-align"
defaultValue="baseline"
defaultChecked
onChange={(event) => setVerticalAlign(event)}
/>
<label htmlFor="vertical-align-baseline">Baseline</label>
<input
type="radio"
id="vertical-align-top"
name="text-vertical-align"
defaultValue="top"
onChange={(event) => setVerticalAlign(event)}
/>
<label htmlFor="vertical-align-top">Top</label>
<input
type="radio"
id="vertical-align-middle"
name="text-vertical-align"
defaultValue="middle"
onChange={(event) => setVerticalAlign(event)}
/>
<label htmlFor="vertical-align-middle">Middle</label>
<input
type="radio"
id="vertical-align-bottom"
name="text-vertical-align"
defaultValue="bottom"
onChange={(event) => setVerticalAlign(event)}
/>
<label htmlFor="vertical-align-bottom">Bottom</label>
</div>
</div>
</div>
<AgCharts ref={chartRef} options={options} />
</Fragment>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
{
title: {
text: [
{ text: '🚀 ', fontSize: 36, verticalAlign: 'baseline' },
{ text: 'Quarterly ', fontSize: 16, verticalAlign: 'baseline' },
{ text: 'Spending ', fontSize: 28, verticalAlign: 'baseline' },
{ text: 'Growth', fontSize: 20, verticalAlign: 'baseline' },
],
},
}In this example:
- Use the buttons to align every segment in the title, moving the large and small text together.
'baseline'and'bottom'differ where text has descenders (such as thep,y, andgin the title): baseline aligns the text baselines, while bottom aligns the lowest pixel of each segment.verticalAlignapplies per segment, so a single line can also mix baseline-aligned text with centred emoji or icon glyphs.
Displaying Images and Text Copy Link
Text Segments support adding inline images using multiple approaches.
Inline Image Segments Copy Link
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
AgChartOptions,
AnimationModule,
BarSeriesModule,
CategoryAxisModule,
LegendModule,
ModuleRegistry,
NumberAxisModule,
} from "ag-charts-enterprise";
import { TData, getData } from "./data";
const flagsUrl = "https://www.ag-grid.com/charts/example-assets/flags/";
const arrowUp =
"data:image/svg+xml;utf8," +
encodeURIComponent(
'<svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 16 16"><path fill="#22c55e" d="M8 2 14 12H2z"/></svg>',
);
const arrowDown =
"data:image/svg+xml;utf8," +
encodeURIComponent(
'<svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 16 16"><path fill="#d62728" d="M8 14 2 4h12z"/></svg>',
);
ModuleRegistry.registerModules([
AnimationModule,
BarSeriesModule,
CategoryAxisModule,
LegendModule,
NumberAxisModule,
]);
const ChartExample = () => {
const [options, setOptions] = useState<AgChartOptions>({
title: {
text: [
{ text: "Top Markets " },
{
type: "image",
url: flagsUrl + "us.png",
width: 24,
height: 18,
verticalAlign: "middle",
},
{ text: " 2025", fontWeight: "bold" },
],
fontSize: 22,
},
subtitle: {
text: "Quarterly revenue by country",
},
data: getData(),
series: [
{
type: "bar",
xKey: "code",
yKey: "revenue",
yName: "Revenue",
label: {
enabled: true,
fill: { ref: "backgroundColor" } as any,
color: { ref: "foregroundColor" },
formatter: ({ datum }) => {
const d = datum as TData;
return [
{ text: `${d.revenue}M `, fontWeight: "bold" },
{
type: "image",
url: d.delta >= 0 ? arrowUp : arrowDown,
width: 12,
height: 12,
verticalAlign: "middle",
},
];
},
},
},
],
axes: {
x: {
type: "category",
label: {
formatter: ({ value }) => [
{
type: "image",
url: flagsUrl + `${value}.png`,
width: 20,
height: 15,
verticalAlign: "middle",
},
{ text: ` ${String(value).toUpperCase()}`, fontWeight: "bold" },
],
},
},
y: {
type: "number",
label: { formatter: ({ value }) => `$${value}M` },
},
},
});
return <AgCharts options={options} />;
};
const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
export interface TData {
code: string;
name: string;
revenue: number;
delta: number;
}
export function getData(): TData[] {
return [
{ code: "us", name: "United States", revenue: 482, delta: 18 },
{ code: "gb", name: "United Kingdom", revenue: 264, delta: -7 },
{ code: "de", name: "Germany", revenue: 318, delta: 12 },
{ code: "fr", name: "France", revenue: 197, delta: 4 },
{ code: "br", name: "Brazil", revenue: 132, delta: -3 },
];
}
Provide any image URL through the url property:
{
axes: {
x: {
type: 'category',
label: {
formatter: ({ value }) => [
{
type: 'image',
url: flagsUrl + `${value}.png`,
width: 20,
height: 15,
verticalAlign: 'middle',
},
{ text: ` ${String(value).toUpperCase()}`, fontWeight: 'bold' },
],
},
},
},
}An image segment uses type: 'image' and supports:
widthandheight- these are required.verticalAlign- vertical alignment against the text.cornerRadius,padding- for styling the image box.backgroundFill- also shows as a placeholder while the image loads or if it fails.overflowStrategy- drop priority for label collision avoidance.'hide'- images are dropped before text is truncated.'keep'images take priority, dropping trailing text first and only dropping the image if it cannot fit on its own.
Block Image Segments Copy Link
Set block: true on an image that begins a row, and the text segments that follow wrap into a column to its right instead of continuing on the same line.
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
AgChartOptions,
AnimationModule,
LegendModule,
ModuleRegistry,
TreemapSeriesModule,
} from "ag-charts-enterprise";
import { TData, getData } from "./data";
const brandIconsUrl = "https://www.ag-grid.com/charts/example-assets/brand-icons/";
ModuleRegistry.registerModules([
AnimationModule,
LegendModule,
TreemapSeriesModule,
]);
const ChartExample = () => {
const [options, setOptions] = useState<AgChartOptions>({
data: getData(),
series: [
{
type: "treemap",
labelKey: "name",
sizeKey: "value",
group: {
label: {
fontSize: 14,
color: "#fff",
},
},
tile: {
label: {
formatter: ({ datum }) => {
const d = datum as TData;
return [
{
type: "image",
url: brandIconsUrl + `${d.slug}.svg`,
width: 36,
height: 36,
block: true,
padding: 6,
backgroundFill: "rgba(0, 0, 0, 0.35)",
cornerRadius: 8,
},
{ text: d.name, fontWeight: "bold", verticalAlign: "middle" },
{ text: `\n$${d.value}B`, color: "rgba(0, 0, 0, 0.6)" },
];
},
fontSize: 16,
minimumFontSize: 10,
spacing: 2,
},
secondaryLabel: { enabled: false },
},
},
],
title: { text: "Top Tech Brand Values, 2024" },
subtitle: { text: "Brand value in USD billions" },
});
return <AgCharts options={options} />;
};
const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
export interface TData {
name: string;
slug: string;
value: number;
}
export interface TGroup {
name: string;
children: TData[];
}
export function getData(): TGroup[] {
return [
{
name: "Hardware",
children: [
{ name: "Apple", slug: "apple", value: 383 },
{ name: "NVIDIA", slug: "nvidia", value: 244 },
{ name: "Intel", slug: "intel", value: 87 },
{ name: "Tesla", slug: "tesla", value: 67 },
],
},
{
name: "Software",
children: [
{ name: "Google", slug: "google", value: 333 },
{ name: "Meta", slug: "meta", value: 196 },
{ name: "SAP", slug: "sap", value: 58 },
{ name: "Shopify", slug: "shopify", value: 36 },
],
},
{
name: "Services",
children: [
{ name: "Netflix", slug: "netflix", value: 38 },
{ name: "Spotify", slug: "spotify", value: 21 },
{ name: "Airbnb", slug: "airbnb", value: 24 },
{ name: "Uber", slug: "uber", value: 32 },
{ name: "PayPal", slug: "paypal", value: 27 },
{ name: "Stripe", slug: "stripe", value: 14 },
],
},
];
}
{
type: 'image',
url: brandIconsUrl + `${datum.slug}.svg`,
width: 36,
height: 36,
block: true,
padding: 6,
backgroundFill: 'rgba(0, 0, 0, 0.35)',
cornerRadius: 8,
}In this example:
- The block image segment anchors to the left of its row, with the following text wrapping into a column to its right. The column can span multiple lines.
- Defaults
verticalAlignto'middle', centring the image against the text column beside it. - Is dropped when its row has no space for it, leaving the text to use the full width. This is controlled by the
overflowStrategyoption.
Emojis and Font Icons Copy Link
Emojis and font icons render through native canvas, with no API changes required. Both can be mixed freely with text within a single element.
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
AgChartOptions,
AnimationModule,
BarSeriesModule,
CategoryAxisModule,
LegendModule,
ModuleRegistry,
NumberAxisModule,
} from "ag-charts-enterprise";
import { TData, getData } from "./data";
const data = getData();
// Keycap number emoji (U+0031..U+0035 + U+FE0F + U+20E3) rank each country by position.
const rankEmoji = ["1️⃣", "2️⃣", "3️⃣", "4️⃣", "5️⃣"];
const rankByCountry = new Map(data.map((d, i) => [d.country, rankEmoji[i]]));
const ICON_FAMILY_SOLID = "Font Awesome 6 Free";
const SOLID_WEIGHT = 900;
const ICON_CHART_LINE = "";
const ICON_STAR = "";
ModuleRegistry.registerModules([
AnimationModule,
BarSeriesModule,
CategoryAxisModule,
LegendModule,
NumberAxisModule,
]);
const ChartExample = () => {
const [options, setOptions] = useState<AgChartOptions>({
title: {
text: [
{
text: `${ICON_CHART_LINE} `,
fontFamily: ICON_FAMILY_SOLID,
fontWeight: SOLID_WEIGHT,
color: "#1f77b4",
verticalAlign: "middle",
},
{ text: "Top Markets 2025", fontWeight: "bold" },
{
text: ` ${ICON_STAR}`,
fontFamily: ICON_FAMILY_SOLID,
fontWeight: SOLID_WEIGHT,
color: "#f1c40f",
verticalAlign: "middle",
},
],
fontSize: 22,
},
subtitle: {
text: [
{
text: `${ICON_CHART_LINE} `,
fontFamily: ICON_FAMILY_SOLID,
fontWeight: SOLID_WEIGHT,
color: "#1f77b4",
verticalAlign: "middle",
},
{ text: "Quarterly revenue by country" },
],
},
data,
series: [
{
type: "bar",
xKey: "country",
yKey: "revenue",
yName: "Revenue",
label: {
enabled: true,
formatter: ({ datum }) => `${(datum as TData).revenue}M`,
},
},
],
axes: {
x: {
type: "category",
label: {
formatter: ({ value }) => [
{
text: `${rankByCountry.get(String(value)) ?? ""} `,
fontSize: 18,
verticalAlign: "middle",
},
{
text: String(value),
fontWeight: "bold",
verticalAlign: "middle",
},
],
},
},
y: {
type: "number",
label: { formatter: ({ value }) => `$${value}M` },
},
},
});
return <AgCharts options={options} />;
};
const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
export interface TData {
country: string;
revenue: number;
delta: number;
}
export function getData(): TData[] {
return [
{ country: "US", revenue: 482, delta: 18 },
{ country: "GB", revenue: 264, delta: -7 },
{ country: "DE", revenue: 318, delta: 12 },
{ country: "JP", revenue: 197, delta: 4 },
{ country: "BR", revenue: 132, delta: -3 },
];
}
In this example:
- The axis labels use number emojis within the
textproperty of aTextSegmentobject. - The title uses a FontAwesome glyph to add a chart icon and a star.
- Font icons set the icon font with
fontFamilyandfontWeighton the segment and use the icon's glyph as thetext. - They are loaded via CSS, with the chart downloading any referenced fonts and re-rendering once they are ready.
- Font icons set the icon font with
{
axes: {
x: {
type: 'category',
label: {
formatter: ({ value }) => [
{ text: '1️⃣ ', fontSize: 18, verticalAlign: 'middle' },
{ text: String(value), fontWeight: 'bold', verticalAlign: 'middle' },
],
},
},
},
}{
title: {
text: [
{
text: `${ICON_CHART_LINE} `,
fontFamily: ICON_FAMILY_SOLID,
fontWeight: SOLID_WEIGHT,
color: '#1f77b4',
verticalAlign: 'middle',
},
{ text: 'Top Markets 2025', fontWeight: 'bold' },
{
text: ` ${ICON_STAR}`,
fontFamily: ICON_FAMILY_SOLID,
fontWeight: SOLID_WEIGHT,
color: '#f1c40f',
verticalAlign: 'middle',
},
],
fontSize: 22,
},
} API Reference Copy Link
See API Options for the full list of font options on each chart element.